unit ActionApp2U;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QMenus, QTypes, QImgList, QActnList, QComCtrls, QButtons;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    edtEntry: TEdit;
    lstEntries: TListBox;
    btnAddString: TBitBtn;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ActionList: TActionList;
    actAddString: TAction;
    ImageList: TImageList;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    AddString1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    PopupMenu: TPopupMenu;
    AddString2: TMenuItem;
    procedure actAddStringExecute(Sender: TObject);
    procedure actAddStringUpdate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.actAddStringExecute(Sender: TObject);
begin
  lstEntries.Items.Add( Trim( edtEntry.Text ) );
  //Give focus back to edit
  edtEntry.SetFocus;
  //Highlight edit's contents so it can be replaced by overtyping
  edtEntry.SelectAll;
end;

procedure TForm1.actAddStringUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled :=
    ( Length( Trim( edtEntry.Text ) ) > 0 ) and
    ( lstEntries.Items.IndexOf( Trim( edtEntry.Text ) ) = -1 )
end;

end.
